/*

  C example using DNS

  Written by Nicolai Langfeldt, May 2000 for inclusion in the book
  "The Concise guide to DNS and BIND" published by MCP.

  This code is in the Public Domain.  Use it as you wish. Neither
  Nicolai Langfeldt or MCP can be held liable for any consequences of
  its use in any context.

*/

#include <netdb.h>
#include <stdlib.h>
#include <errno.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <string.h>

/* This code will probably not work with IPv6 */

void do_lookup(char *name)


{
  /* Look up the IP address of the host named by the variable "name" */

  struct hostent *rhost;	/* Host lookup address */
  struct in_addr addr;		/* TMP: Address for inet_ntoa */
  unsigned long inaddr;		/* IP address (IPv4 only) */
  
  char *ipstr;			/* IP address as a string */
  int tcp_port;			/* Port number */
  int cd;			/* Connection descriptor */

  /* First try to convert IP-number to address */
  if ((inaddr = inet_addr(name)) != INADDR_NONE) {
    ipstr=name;
  } else {
    /* Look up A (or AAAA) record of the host.  This code should work
       for any address protocol. */
    rhost = gethostbyname(name);

    /* Check return value */
    if (rhost==NULL) {
      printf("%s could not be resolved\n",name);
      return;
    }

    memcpy(&addr,rhost->h_addr,rhost->h_length);

    ipstr = inet_ntoa(addr);
  }

  printf("The address of %s is %s\n",name,ipstr);
}
  
	 

int main(void)

{
  do_lookup("www.amazon.com");
  do_lookup("lala.amazon.com");
  do_lookup("www.linpro.no");
  return 0;
}

