#!/bin/ksh
#
# Shell script examples using DNS.
#
# Written by Nicolai Langfeldt, May 2000 for inclusion in the book
# "The Concise guide to DNS and BIND" published by MCP.
#
# This code is in the Public Domain.  Use it as you wish. Neither
# Nicolai Langfeldt or MCP can be held liable for any consequences of
# its use in any context.

dig_lookup () {
    host=$1; shift

    address=$(dig $host +pfmin 2>/dev/null | awk '
		/IN A/	  { print $(NF); exit 0; } 
		/NOERROR/ { next; } 
		/status:/ { exit 1; }')

    case $address in
	'') print error looking up $host;;
	*)  print $host has address $address;;
    esac
}

ns_lookup () {
    host=$1; shift

    address=$(nslookup $host 2>&1 | awk '
		/^Address:/ { a=$(NF); }
		/\*\*\*/    { exit 1; }
		END	    { print a; }')

    case $address in
	'') print error looking up $host;;
	*)  print $host has address $address;;
    esac
}

print DIG lookups:      
dig_lookup www.amazon.com.
dig_lookup lala.amazon.com.
dig_lookup www.linpro.no.

print nslookup:
ns_lookup www.amazon.com.
ns_lookup lala.amazon.com.
ns_lookup www.linpro.no.
